//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.IO;
using System.Net;
using System.Net.Sockets;

namespace AsyncClnt
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class AsyncClientClass
	{
		static void Main(string[] args)
		{
			string server = "localhost";
			if(args.Length == 1)
				server = args[0];
			TcpClient client = new TcpClient();
			client.Connect(server, 5000);
			NetworkStream tcpStream = client.GetStream();
			// Get StreamWriter so we can write strings instead of bytes
			StreamWriter reqStreamW = new StreamWriter(tcpStream);
			// Code for using the TCP server goes here. For example, the
			// following lines write the string in strOutData to the server:
			reqStreamW.Write("Hello Server!");
			// Flush StreamWriter to send data
			reqStreamW.Flush();
			// Get StreamReader so we can read strings instead of bytes
			StreamReader reqStreamR = new StreamReader(tcpStream);
			// The following line reads a string from the server:
			String strInData = reqStreamR.ReadToEnd();
			Console.WriteLine(strInData);
			// Close stream and client
			tcpStream.Close();
			client.Close();
		}
	}
}
