//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
// mfcsodlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMfcsockDlg dialog

class CMfcsockDlg : public CDialog
{
// Construction
public:
	CMfcsockDlg(CWnd* pParent = NULL);	// standard constructor
   void DisplayResults(DWORD dwStartTime, DWORD dwEndTime,
      double dPerfTime, DWORD dwPerfBytesTransmitted,
      double dPerfStats);
   void DoStandardSynchronous(void);
   void DoStandardOverlapped(void);
   void DoCPPOverlapped(void);
   void DoCAsyncSocket(void);
   void DoCSocket(void);
   void DoDatagram(void);
   void DoNamedPipes(void);
   void DoOverlappedPipes(void);
   void DoCPPNamedPipes(void);
   void DoCPPOverlappedPipes(void);
   void DoWNetDlls(void);
   void DoRPC(void);
   BOOL GetHostAddress(LPCSTR lpszHost, 
                       LPCSTR lpszService,
                       LPCSTR lpszProto);

// Dialog Data
	//{{AFX_DATA(CMfcsockDlg)
	enum { IDD = IDD_MFCSOCK_DIALOG };
	UINT	m_nPacketSize;
	UINT	m_nNumPackets;
	CString	m_szTargetServer;
   CString  m_szOSVersion;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMfcsockDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
   SOCKADDR_IN m_sin;
   UINT  m_uControlID;   // Test to perform
   enum {RECV_1, RECV_2, SEND_1, SEND_2};
   HANDLE m_hWNetUser;
   CNamedPipesServer *m_pNamedPipesServer;
   static BOOL WINAPI PipesReceiveCallback(LPBYTE lpData,
      DWORD dwDataLength, HANDLE hConnection);
   static TCHAR m_szComputerName[MAX_COMPUTERNAME_LENGTH + 1];

#ifdef _USE_WINSOCK2_
   HINSTANCE m_hSocketsLib;
   LPFN_WSASTARTUP m_lpfnWSAStartup;
   LPFN_WSACLEANUP m_lpfnWSACleanup;
#endif

	// Generated message map functions
	//{{AFX_MSG(CMfcsockDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	afx_msg void OnCasyncSocket();
	afx_msg void OnCsocket();
	afx_msg void OnStandardOverlapped();
	afx_msg void OnStandardSynchronous();
	afx_msg void OnDatagram();
	afx_msg void OnKillfocusPacketSize();
	afx_msg void OnCppOverlapped();
	afx_msg void OnNamedPipes();
	afx_msg void OnOverlappedPipes();
	virtual void OnCancel();
	afx_msg void OnWnetDlls();
	afx_msg void OnCppNamedPipes();
	afx_msg void OnCppOverlappedPipes();
	afx_msg void OnDouble();
	afx_msg void OnRpc();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
