//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Runtime.InteropServices;

namespace Bench
{
	/// <summary>
	/// Summary description for UnmanagedTcpTest.
	/// </summary>
	class UnmanagedNetworking
	{
		[DllImport("UnmanagedNetworking.dll")]
		public static extern void SynchTcpTest(string server, int port, int nPackets, int packetSize);
		[DllImport("UnmanagedNetworking.dll")]
		public static extern void SynchUdpTest(string server, int port, int nPackets, int packetSize);
		[DllImport("UnmanagedNetworking.dll")]
		public static extern int Start();
		[DllImport("UnmanagedNetworking.dll")]
		public static extern int TransmitByteCount();
		[DllImport("UnmanagedNetworking.dll")]
		public static extern int ReceivedByteCount();
		[DllImport("UnmanagedNetworking.dll")]
		public static extern double Elapsed();
		[DllImport("UnmanagedNetworking.dll")]
		public static extern void Stop();
	}

	public class UnmanagedTcpTest : NetworkTest
	{
		public UnmanagedTcpTest(string server, int port, int numberOfPackets, int packetSize) :
			base(server, port, numberOfPackets, packetSize)
		{
			UnmanagedNetworking.SynchTcpTest(Server, Port, NumberOfPackets, PacketSize);
		}
		public override void Start()
		{
			// Perform the test
			StartCounters();
			int startTime = Environment.TickCount;
			
			UnmanagedNetworking.Start();

			int endTime = Environment.TickCount;
			StopCounters();

			TransmitByteCount = UnmanagedNetworking.TransmitByteCount();
			ReceivedByteCount = UnmanagedNetworking.ReceivedByteCount();
			Elapsed = (float)UnmanagedNetworking.Elapsed();

			UnmanagedNetworking.Stop();
		}
	}
}
