//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Net;
using System.Net.Sockets;

namespace DNSUtilities
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>

        // IDictionaryEnumerator myEnumerator = myList.GetEnumerator();
        // Console.WriteLine( "\t-KEY-\t-VALUE-" );
        // while ( myEnumerator.MoveNext() )
        //    Console.WriteLine( "\t{0}:\t{1}", myEnumerator.Key, myEnumerator.Value );
        // Console.WriteLine();

	class DNSIPAddress
	{
		static void Main(string[] args)
		{
			String strHostName;
			if (args.Length == 0)
			{
				// Getting Ip address of local machine...
				// First get the host name of local machine.
				strHostName = Dns.GetHostName ();
				Console.WriteLine ("Local Machine's Host Name: " +  strHostName);
			}
			else
			{
				strHostName = args[0];
			}
          
			IPHostEntry ipEntry;
			IPAddress [] addr;
			try
			{
				// Then using host name, get the IP address list..
				ipEntry = Dns.GetHostByName (strHostName);
				addr = ipEntry.AddressList;
				for (int i = 0; i < addr.Length; i++)
				{
					Console.WriteLine ("IP Address {0}: {1} ", i, addr[i].ToString ());
				}
			}
			catch(SocketException e)
			{
				Console.WriteLine("SocketException: {0}", e.Message);
			}
			catch(ArgumentNullException e)
			{
				Console.WriteLine("ArgumentNullException: {0}", e.Message);
			}
         
			return;
		}
	}		
}
