//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Text;
using System.Net;
using System.Net.Sockets;

class Listener
{
	public static void Main()
	{
		Console.WriteLine("Ready to process requests...");
		ProcessRequests();	
	}

	public static void ProcessRequests()
	{
		TcpListener client = new TcpListener(5000);
		client.Start();
		// Socket s = client.AcceptSocket();
		TcpClient s = client.AcceptTcpClient();

		byte[] responseData = new byte[128];
		bool continueProcessing = true;

		NetworkStream stream = s.GetStream();
		string message;
		int bytesRead;

		while(continueProcessing)
		{	
			try
			{
				bytesRead = stream.Read(responseData, 0, responseData.Length);
				if(bytesRead == 0)
				{
					// The client disconnected
					continueProcessing = false;
					break;
				}
				else
				{
					message = Encoding.Unicode.GetString(responseData, 0, bytesRead);

					if(message == "quit")
					{
						continueProcessing = false;
						break;
					}
					else
					{
						Console.WriteLine("The message received was " + message);
					}
				}
			}
			catch(Exception ex)
			{
				Console.WriteLine(ex.ToString());
			}
		}

		client.Stop();
	}
}
