//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Text;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Reflection;

class Sender
{

	public static void Main(string[] args)
	{	
		string address = "localhost";
		if(args.Length == 1)
			address = args[0];

		SendMessage(address);
	}

	public static void SendMessage(string server)
	{
		TcpClient client = new TcpClient();
		client.Connect(server, 5000);
		NetworkStream stream = client.GetStream();

		bool continueSending = true;
		while(continueSending)
		{		
			Console.WriteLine("Enter the message to send. Type 'quit' to exit.");
			string message = Console.ReadLine();
			// byte[] buffer = Encoding.ASCII.GetBytes(message);
			byte[] buffer = Encoding.Unicode.GetBytes(message);
			stream.Write(buffer, 0, buffer.Length);
			if(message == "quit")
			{
				continueSending = false;
			}	
		}
				
		client.Close();

		// From: Buksbaum, David [SMTP:david.buksbaum@CSFB.COM]  
		PropertyInfo pi = typeof(TcpClient).GetProperty("Client", 
			BindingFlags.Instance|BindingFlags.NonPublic);
		// mSock is your TcpClient object.
		Socket so = (Socket)pi.GetValue(client, null); 
		if((so != null) && (so.Connected)) 
			so.Shutdown(SocketShutdown.Both);

	}
}
