//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Net;
using System.Text;
using System.Net.Sockets; 

class Sender
{

	public static void Main(string[] args)
	{	
		string address = "localhost";
		if(args.Length == 1)
			address = args[0];
		bool continueSending = true;
		while(continueSending)
		{		
			Console.WriteLine("Enter the message to send. Type 'quit' to exit.");
			string message = Console.ReadLine();
			SendMessage(message, address);
			if(message == "quit")
			{
				SendMessage(message, address);
				continueSending = false;
			}	
		}
	}

	public static void SendMessage(string message, string server)
	{
		UdpClient client = new UdpClient(5002); 
		// byte[] buffer = Encoding.ASCII.GetBytes(message);
		byte[] buffer = Encoding.Unicode.GetBytes(message);
		client.Send(buffer, buffer.Length, server, 5001);		
		client.Close();
	}
}
