//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Net;
using System.Text;
using System.Net.Sockets;

class Listener
{

	public static void Main()
	{
		Console.WriteLine("Ready to process requests...");
		ProcessRequests();	
	}

	public static void ProcessRequests()
	{
		UdpClient listener = new UdpClient(2001);
		IPEndPoint remoteEp = new IPEndPoint(IPAddress.Any, 2001);

		bool continueProcessing = true;
		while(continueProcessing)
		{
			byte[] buffer = listener.Receive(ref remoteEp);
			
			string message = Encoding.ASCII.GetString(buffer, 0, buffer.Length);
			if(message == "quit")
			{
				continueProcessing = false;
				break;
			}
			else
			{
				Console.WriteLine("The message received was " + message);
			}
		}		

		listener.Close();
	}
}
