//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Net;
using System.Text;
using System.IO;
using System.Collections.Specialized;

public class SimpleHTTP
{
	public static void Main(string[] args) 
	{
		try
		{
			string address = "http://localhost/QuickStart/HowTo/";
			if(args.Length == 1)
				address = args[0];

			// WebRequest request = WebRequest.Create(address);
			// WebResponse response = request.GetResponse();
			// StreamReader reader = new StreamReader(response.GetResponseStream(), Encoding.ASCII);
			// Console.WriteLine(reader.ReadToEnd());
			// response.Close();

			WebClient wc = new WebClient();

			// wc.DownloadFile(address, "default.aspx");
			Stream stream = wc.OpenRead(address);

			// Now read in s into a byte buffer.
			byte[] bytes = new byte[1000];
			int numBytesToRead = (int) bytes.Length;
			int numBytesRead = 0;
			while ((numBytesRead = stream.Read(bytes, 0, numBytesToRead)) >= 0) 
			{
				// Read may return anything from 0 to numBytesToRead.
				// We're at EOF
				if (numBytesRead == 0)
					break;
				Console.WriteLine(Encoding.ASCII.GetString(bytes, 0, numBytesRead));
			}
			
			stream.Close();

			NameValueCollection query = wc.QueryString;
			int values = query.Count;

			// byte[] buffer = wc.DownloadData(address);
			// Console.WriteLine(Encoding.ASCII.GetString(buffer));

		}
		catch(Exception ex)
		{
			Console.WriteLine(ex.ToString());
		}		
	}
}
